Name:          mybatis-generator
Version:       1.3.2
Release:       4%{?dist}
Summary:       A code generator for MyBatis and iBATIS
License:       ASL 2.0
URL:           http://www.mybatis.org/
Source0:       https://github.com/mybatis/generator/archive/%{name}-%{version}.tar.gz

BuildRequires: java-devel

BuildRequires: mvn(log4j:log4j)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
BuildRequires: mvn(org.apache.maven:maven-project)
BuildRequires: mvn(org.mybatis:mybatis)
BuildRequires: mvn(org.mybatis:mybatis-parent)
# test deps
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.commons:commons-ognl)
BuildRequires: mvn(org.hsqldb:hsqldb)

# mybatis-generator-maven-plugin runtime deps
# mvn(org.hsqldb:hsqldb)
BuildRequires: mvn(net.sourceforge.cobertura:cobertura)

BuildRequires: maven-local
BuildRequires: maven-changes-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-plugin-bundle
BuildRequires: maven-plugin-plugin
BuildRequires: maven-surefire-report-plugin
# required by changes-plugin
BuildRequires: mvn(org.apache.xmlrpc:xmlrpc-client)

BuildArch:     noarch

%description
MyBatis Generator (MBG) is a code generator for MyBatis and iBATIS.

%package maven-plugin
Summary:       MyBatis Generator Maven Plugin

%description maven-plugin
MyBatis Generator Maven Plugin.

%package systests-common
Summary:       MyBatis Generator Tests (Common Classes)

%description systests-common
MyBatis Generator Tests (Common Classes).

%package systests-mybatis3
Summary:       MyBatis Generator Tests (MyBatis3)

%description systests-mybatis3
MyBatis Generator Tests (MyBatis3).

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n generator-%{name}-%{version}

# Unavailable deps org.apache.ibatis:ibatis-sqlmap:2.3.4.726
%pom_disable_module %{name}-systests-ibatis2-java2
%pom_disable_module %{name}-systests-ibatis2-java5
%pom_remove_dep :ibatis-sqlmap

# Remove, cause build failure
%pom_remove_plugin :maven-enforcer-plugin

# Unavailable plugin
%pom_remove_plugin :maven-gcu-plugin %{name}-core
%pom_remove_plugin :jdepend-maven-plugin %{name}-core
# Unwanted plugin
%pom_remove_plugin :maven-install-plugin %{name}-core
%pom_remove_plugin :maven-assembly-plugin %{name}-core
%pom_remove_plugin :maven-javadoc-plugin %{name}-core
%pom_remove_plugin :maven-release-plugin %{name}-core
%pom_remove_plugin :maven-site-plugin %{name}-core
%pom_remove_plugin :maven-source-plugin %{name}-core
# Disable cobertura plugin
%pom_remove_plugin :cobertura-maven-plugin %{name}-core
%pom_xpath_remove "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='maven-jar-plugin']/pom:executions" %{name}-core
%pom_xpath_remove "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId='mybatis-generator-maven-plugin']/pom:dependencies/pom:dependency[pom:artifactId='mybatis-generator-core']/pom:classifier" %{name}-systests-mybatis3

# java.lang.NoClassDefFoundError: org/apache/commons/ognl/PropertyAccessor
%pom_add_dep org.apache.commons:commons-ognl::test mybatis-generator-systests-mybatis3

sed -i 's/\r//' LICENSE NOTICE %{name}-core/doc/*

%build

%mvn_package ":%{name}" %{name}
%mvn_package ":%{name}-core" %{name}
# Running mbg.test.mb3.hierarchical.UpdateByExampleTest
# Tests run: 17, Failures: 0, Errors: 1, Skipped: 0, Time elapsed: 4.498 sec <<< FAILURE! 
#       - in mbg.test.mb3.hierarchical.UpdateByExampleTest
#       testAwfulTableUpdateByExampleSelective(mbg.test.mb3.hierarchical.UpdateByExampleTest)  Time elapsed: 1.27 sec  <<< ERROR!
#       org.apache.ibatis.exceptions.PersistenceException: 
### Error updating database.  Cause: org.apache.ibatis.builder.BuilderException: 
#       Error evaluating expression 'record.eMail != null'. Cause: org.apache.commons.ognl.NoSuchPropertyException:
#       mbg.test.mb3.generated.hierarchical.model.AwfulTable.eMail
### Cause: org.apache.ibatis.builder.BuilderException: Error evaluating expression
#       'record.eMail != null'. Cause: org.apache.commons.ognl.NoSuchPropertyException:
#       mbg.test.mb3.generated.hierarchical.model.AwfulTable.eMail
#	at org.apache.commons.ognl.ObjectPropertyAccessor.getProperty(ObjectPropertyAccessor.java:140)
%mvn_build -s -- -Dmaven.test.failure.ignore=true

%install
%mvn_install

%files -f .mfiles-%{name}
%doc LICENSE NOTICE %{name}-core/doc/*

%files maven-plugin -f .mfiles-%{name}-maven-plugin
%doc LICENSE NOTICE

%files systests-common -f .mfiles-%{name}-systests-common
%doc LICENSE NOTICE

%files systests-mybatis3 -f .mfiles-%{name}-systests-mybatis3
%doc LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%doc LICENSE NOTICE

%changelog
* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.3.2-3
- Use Requires: java-headless rebuild (#1067528)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jul 18 2013 gil cattaneo <puntogil@libero.it> 1.3.2-1
- initial rpm